## org.hibernate.type
Interface Type

All Superinterfaces:
  Serializable

All Known Subinterfaces:
  AbstractComponentType, AssociationType, BasicType, CompositeType, DiscriminatorType<T>, IdentifierType<T>, SingleColumnType<T>, VersionType<T>

All Known Implementing Classes:
  AbstractBynaryType, AbstractCharArrayType, AbstractLobType, AbstractLongBinaryType, AbstractLongStringType, AbstractSingleColumnStandardBasicType, AbstractStandardBasicType, AbstractType, AdaptedImmutableType, AnyType, ArrayType, BagType, BigDecimalType, BigIntegerType, BinaryType, BlobType, BooleanType, ByteArrayBlobType, ByteType, CalendarDateType, CalendarType, CharacterArrayClobType, CharacterArrayType, CharacterType, CharArrayType, CharBooleanType, ClassType, ClobType, CollectionType, ComponentType, CompositeCustomType, CurrencyType, CustomCollectionType, CustomType, DateType, DbTimestampType, DiscriminatorType, DoubleType, EmbeddedComponentType, EntityType, FloatType, IdentifierBagType, ImageType, ImmutableType, IntegerType, ListType, LobType, LocaleType, LongType, ManyToOneType, MapType, MaterializedBlobType, MaterializedClobType, MetaType, MutableType, NullableType, NumericBooleanType, ObjectType, OneToOneType, OrderedMapType, OrderedSetType, PostgresUUIDType, PrimitiveByteArrayBlobType, PrimitiveCharacterArrayClobType, SerializableToBlobType, SerializableType, SetType, ShortType, SortedMapType, SortedSetType, SpecialOneToOneType, StringType, TextType, TimestampType, TimeType, TimeZoneType, TrueFalseType, UrlType, UUIDBinaryType, UUIDCharType, WrappedMaterializedBlobType, WrapperBinaryType, YesNoType

    public interface Type

extends Serializable

Defines a mapping between a Java type and one or more JDBC types, as well as describing the in-memory semantics of the given java type (how do we check it for 'dirtiness', how do we copy values, etc).

Application developers needing custom types can implement this interface (either directly or via subclassing an existing impl) or by the (slightly more stable, though more limited) `UserType` interface.

Implementations of this interface must certainly be thread-safe. It is recommended that they be immutable as well, though that is difficult to achieve completely given the no-arg constructor requirement for custom types.

Author:
  Gavin King, Steve Ebersole

Method Summary
`Object` `assemble(Serializable cached, SessionImplementor session, Object owner)` Reconstruct the object from its cached "disassembled" state.
`void` `beforeAssemble(Serializable cached, SessionImplementor session)` Called before assembling a query result set from the query cache, to allow batch fetching of entities missing from the second-level cache.
`int` `compare(Object x, Object y, EntityMode entityMode)` Perform a `Comparator` style comparison between values
`Object` `deepCopy(Object value, EntityMode entityMode, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`Serializable` `disassemble(Object value, SessionImplementor session, Object owner)` Return a cacheable "disassembled" representation of the object.
`Object` `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`int` `getColumnSpan(Mapping mapping)` How many columns are used to persist this type.
`int` `getHashCode(Object x, EntityMode entityMode)` Get a hash code, consistent with persistence "equality".
`int` `getHashCode(Object x, EntityMode entityMode, SessionFactoryImplementor factory)` Get a hash code, consistent with persistence "equality".
`String` `getName()` Returns the abbreviated name of the type.
`Class` `getReturnedClass()` The class returned by `nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.SessionImplementor, java.lang.Object)` methods.
`Type` `getSemiResolvedType(SessionFactoryImplementor factory)` Get the type of a semi-resolved value.
`Object` `hydrate(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Retrieve an instance of the mapped class, or the identifier of an entity or collection, from a JDBC resultset.
`boolean` `isAnyType()` Return true if the implementation is castable to `AnyType`.
`boolean` `isAssociationType()` Return true if the implementation is castable to `AssociationType`.
`boolean` `isCollectionType()` Return true if the implementation is castable to `CollectionType`.
`boolean` `isComponentType()` Return true if the implementation is castable to `CompositeType`.
`boolean` `isDirty(Object oldState, Object currentState, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` `isDirty(Object old, Object current, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` `isEntityType()` Return true if the implementation is castable to `EntityType`.
`boolean` `isEqual(Object x, Object y, EntityMode entityMode)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` `isEqual(Object x, Object y, EntityMode entityMode, SessionFactoryImplementor factory)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` `isModified(Object dbState, Object currentState, boolean[] checkable, SessionImplementor session)` Has the value been modified compared to the current database state? The difference between this and the `isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.SessionImplementor)` methods is that here we need to account for "partially" built values.
`boolean` `isMutable()` Are objects of this type mutable.
`boolean` `isSame(Object x, Object y, EntityMode entityMode)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.
`boolean` `isXMLElement()`
`Object` `nullSafeGet(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Retrieve an instance of the mapped class from a JDBC resultset.
`Object` `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Retrieve an instance of the mapped class from a JDBC resultset.
`void` `nullSafeSet(PreparedStatement st, Object value, int index, boolean[] settable, SessionImplementor session)` Write an instance of the mapped class to a prepared statement, ignoring some columns.
`void` `nullSafeSet(PreparedStatement st, Object value, int index, SessionImplementor session)` Write an instance of the mapped class to a prepared statement.
`Object` `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache, ForeignKeyDirection foreignKeyDirection)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` `resolve(Object value, SessionImplementor session, Object owner)` Map identifiers to entities or collections.
`Object` `semiResolve(Object value, SessionImplementor session, Object owner)` Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.
`void` `setToXMLNode(org.dom4j.Node node, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` `sqlTypes(Mapping mapping)` Return the JDBC types codes (per `Types`) for the columns mapped by this type.
`boolean[]` `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` `toLoggableString(Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in a log file.

Method Detail

### isAssociationType

    boolean isAssociationType()

  Return true if the implementation is castable to `AssociationType`. This does not necessarily imply that the type actually represents an association. Essentially a polymorphic version of `(type instanceof AssociationType.class)`

  Returns:
    True if this type is also an `AssociationType` implementor; false otherwise.

### isCollectionType

    boolean isCollectionType()

  Return true if the implementation is castable to `CollectionType`. Essentially a polymorphic version of `(type instanceof CollectionType.class)`

  A `CollectionType` is additionally an `AssociationType`; so if this method returns true, `isAssociationType()` should also return true.

  Returns:
    True if this type is also an `CollectionType` implementor; false otherwise.

### isEntityType

    boolean isEntityType()

  Return true if the implementation is castable to `EntityType`. Essentially a polymorphic version of `(type instanceof EntityType.class)`.

  An `EntityType` is additionally an `AssociationType`; so if this method returns true, `isAssociationType()` should also return true.

  Returns:
    True if this type is also an `EntityType` implementor; false otherwise.

### isAnyType

    boolean isAnyType()

  Return true if the implementation is castable to `AnyType`. Essentially a polymorphic version of `(type instanceof AnyType.class)`.

  An `AnyType` is additionally an `AssociationType`; so if this method returns true, `isAssociationType()` should also return true.

  Returns:
    True if this type is also an `AnyType` implementor; false otherwise.

### isComponentType

    boolean isComponentType()

  Return true if the implementation is castable to `CompositeType`. Essentially a polymorphic version of `(type instanceof CompositeType.class)`. A component type may own collections or associations and hence must provide certain extra functionality.

  Returns:
    True if this type is also an `CompositeType` implementor; false otherwise.

### sqlTypes

    int[] sqlTypes(Mapping mapping)
                   throws MappingException

  Return the JDBC types codes (per `Types`) for the columns mapped by this type.

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The JDBC type codes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### getColumnSpan

    int getColumnSpan(Mapping mapping)
                      throws MappingException

  How many columns are used to persist this type. Always the same as `sqlTypes(mapping).length`

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The number of columns
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### getReturnedClass

    Class getReturnedClass()

  The class returned by `nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.SessionImplementor, java.lang.Object)` methods. This is used to establish the class of an array of this type.

  Returns:
    The java type class handled by this type.

### isXMLElement

    boolean isXMLElement()

### isSame

    boolean isSame(Object x,
                   Object y,
                   EntityMode entityMode)
                   throws HibernateException

  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.

  For most types this should equate to `#equals` check on the values. For associations the implication is a bit different. For most types it is conceivable to simply delegate to `isEqual(java.lang.Object, java.lang.Object, org.hibernate.EntityMode)`

  Parameters:
    `x` - The first value
    `y` - The second value
    `entityMode` - The entity mode of the values.
  Returns:
    True if there are considered the same (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### isEqual

    boolean isEqual(Object x,
                    Object y,
                    EntityMode entityMode)
                    throws HibernateException

  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Parameters:
    `x` - The first value
    `y` - The second value
    `entityMode` - The entity mode of the values.
  Returns:
    True if there are considered equal (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### isEqual

    boolean isEqual(Object x,
                    Object y,
                    EntityMode entityMode,
                    SessionFactoryImplementor factory)
                    throws HibernateException

  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Parameters:
    `x` - The first value
    `y` - The second value
    `entityMode` - The entity mode of the values.
    `factory` - The session factory
  Returns:
    True if there are considered equal (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### getHashCode

    int getHashCode(Object x,
                    EntityMode entityMode)
                    throws HibernateException

  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `#hashCode`.

  Parameters:
    `x` - The value for which to retrieve a hash code
    `entityMode` - The entity mode of the value.
  Returns:
    The hash code
  Throws:
    `HibernateException` - A problem occurred calculating the hash code

### getHashCode

    int getHashCode(Object x,
                    EntityMode entityMode,
                    SessionFactoryImplementor factory)
                    throws HibernateException

  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `#hashCode`.

  Parameters:
    `x` - The value for which to retrieve a hash code
    `entityMode` - The entity mode of the value.
    `factory` - The session factory
  Returns:
    The hash code
  Throws:
    `HibernateException` - A problem occurred calculating the hash code

### compare

    int compare(Object x,
                Object y,
                EntityMode entityMode)

  Perform a `Comparator` style comparison between values

  Parameters:
    `x` - The first value
    `y` - The second value
    `entityMode` - The entity mode of the values.
  Returns:
    The comparison result. See `Comparator.compare(T, T)` for a discussion.

### isDirty

    boolean isDirty(Object old,
                    Object current,
                    SessionImplementor session)
                    throws HibernateException

  Should the parent be considered dirty, given both the old and current value?

  Parameters:
    `old` - the old value
    `current` - the current value
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isDirty

    boolean isDirty(Object oldState,
                    Object currentState,
                    boolean[] checkable,
                    SessionImplementor session)
                    throws HibernateException

  Should the parent be considered dirty, given both the old and current value?

  Parameters:
    `oldState` - the old value
    `currentState` - the current value
    `checkable` - An array of booleans indicating which columns making up the value are actually checkable
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isModified

    boolean isModified(Object dbState,
                       Object currentState,
                       boolean[] checkable,
                       SessionImplementor session)
                       throws HibernateException

  Has the value been modified compared to the current database state? The difference between this and the `isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.SessionImplementor)` methods is that here we need to account for "partially" built values. This is really only an issue with association types. For most type implementations it is enough to simply delegate to `isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.SessionImplementor)` here/

  Parameters:
    `dbState` - the database state, in a "hydrated" form, with identifiers unresolved
    `currentState` - the current state of the object
    `checkable` - which columns are actually updatable
    `session` - The session from which the request originated.
  Returns:
    true if the field has been modified
  Throws:
    `HibernateException` - A problem occurred performing the checking

### nullSafeGet

    Object nullSafeGet(ResultSet rs,
                       String[] names,
                       SessionImplementor session,
                       Object owner)
                       throws HibernateException,
                              SQLException

  Retrieve an instance of the mapped class from a JDBC resultset. Implementors should handle possibility of null values.

  Parameters:
    `rs` -
    `names` - the column names
    `session` -
    `owner` - the parent entity
  Returns:
    Object
  Throws:
    `HibernateException`
    `SQLException`
  See Also:
    `alternative, 2-phase property initialization`

### nullSafeGet

    Object nullSafeGet(ResultSet rs,
                       String name,
                       SessionImplementor session,
                       Object owner)
                       throws HibernateException,
                              SQLException

  Retrieve an instance of the mapped class from a JDBC resultset. Implementations should handle possibility of null values. This method might be called if the type is known to be a single-column type.

  Parameters:
    `rs` -
    `name` - the column name
    `session` -
    `owner` - the parent entity
  Returns:
    Object
  Throws:
    `HibernateException`
    `SQLException`

### nullSafeSet

    void nullSafeSet(PreparedStatement st,
                     Object value,
                     int index,
                     boolean[] settable,
                     SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Write an instance of the mapped class to a prepared statement, ignoring some columns. Implementors should handle possibility of null values. A multi-column type should be written to parameters starting from `index`.

  Parameters:
    `st` -
    `value` - the object to write
    `index` - statement parameter index
    `settable` - an array indicating which columns to ignore
    `session` -
  Throws:
    `HibernateException`
    `SQLException`

### nullSafeSet

    void nullSafeSet(PreparedStatement st,
                     Object value,
                     int index,
                     SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Write an instance of the mapped class to a prepared statement. Implementors should handle possibility of null values. A multi-column type should be written to parameters starting from `index`.

  Parameters:
    `st` -
    `value` - the object to write
    `index` - statement parameter index
    `session` -
  Throws:
    `HibernateException`
    `SQLException`

### setToXMLNode

    void setToXMLNode(org.dom4j.Node node,
                      Object value,
                      SessionFactoryImplementor factory)
                      throws HibernateException

  A representation of the value to be embedded in an XML element.

  Parameters:
    `value` -
    `factory` -
  Throws:
    `HibernateException`

### toLoggableString

    String toLoggableString(Object value,
                            SessionFactoryImplementor factory)
                            throws HibernateException

  A representation of the value to be embedded in a log file.

  Parameters:
    `value` -
    `factory` -
  Returns:
    String
  Throws:
    `HibernateException`

### fromXMLNode

    Object fromXMLNode(org.dom4j.Node xml,
                       Mapping factory)
                       throws HibernateException

  Parse the XML representation of an instance.

  Parameters:
    `xml` -
    `factory` -
  Returns:
    an instance of the type
  Throws:
    `HibernateException`

### getName

    String getName()

  Returns the abbreviated name of the type.

  Returns:
    String the Hibernate type name

### deepCopy

    Object deepCopy(Object value,
                    EntityMode entityMode,
                    SessionFactoryImplementor factory)
                    throws HibernateException

  Return a deep copy of the persistent state, stopping at entities and at collections.

  Parameters:
    `value` - generally a collection element or entity field
    `entityMode` -
    `factory` -
  Returns:
    Object a copy
  Throws:
    `HibernateException`

### isMutable

    boolean isMutable()

  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Returns:
    boolean

### disassemble

    Serializable disassemble(Object value,
                             SessionImplementor session,
                             Object owner)
                             throws HibernateException

  Return a cacheable "disassembled" representation of the object.

  Parameters:
    `value` - the value to cache
    `session` - the session
    `owner` - optional parent entity object (needed for collections)
  Returns:
    the disassembled, deep cloned state
  Throws:
    `HibernateException`

### assemble

    Object assemble(Serializable cached,
                    SessionImplementor session,
                    Object owner)
                    throws HibernateException

  Reconstruct the object from its cached "disassembled" state.

  Parameters:
    `cached` - the disassembled state from the cache
    `session` - the session
    `owner` - the parent entity object
  Returns:
    the the object
  Throws:
    `HibernateException`

### beforeAssemble

    void beforeAssemble(Serializable cached,
                        SessionImplementor session)

  Called before assembling a query result set from the query cache, to allow batch fetching of entities missing from the second-level cache.

### hydrate

    Object hydrate(ResultSet rs,
                   String[] names,
                   SessionImplementor session,
                   Object owner)
                   throws HibernateException,
                          SQLException

  Retrieve an instance of the mapped class, or the identifier of an entity or collection, from a JDBC resultset. This is useful for 2-phase property initialization - the second phase is a call to `resolveIdentifier()`.

  Parameters:
    `rs` -
    `names` - the column names
    `session` - the session
    `owner` - the parent entity
  Returns:
    Object an identifier or actual value
  Throws:
    `HibernateException`
    `SQLException`
  See Also:
    `resolve(Object, SessionImplementor, Object)`

### resolve

    Object resolve(Object value,
                   SessionImplementor session,
                   Object owner)
                   throws HibernateException

  Map identifiers to entities or collections. This is the second phase of 2-phase property initialization.

  Parameters:
    `value` - an identifier or value returned by `hydrate()`
    `owner` - the parent entity
    `session` - the session
  Returns:
    the given value, or the value associated with the identifier
  Throws:
    `HibernateException`
  See Also:
    `hydrate(ResultSet, String[], SessionImplementor, Object)`

### semiResolve

    Object semiResolve(Object value,
                       SessionImplementor session,
                       Object owner)
                       throws HibernateException

  Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.

  Throws:
    `HibernateException`

### getSemiResolvedType

    Type getSemiResolvedType(SessionFactoryImplementor factory)

  Get the type of a semi-resolved value.

### replace

    Object replace(Object original,
                   Object target,
                   SessionImplementor session,
                   Object owner,
                   Map copyCache)
                   throws HibernateException

  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
  Returns:
    the value to be merged
  Throws:
    `HibernateException`

### replace

    Object replace(Object original,
                   Object target,
                   SessionImplementor session,
                   Object owner,
                   Map copyCache,
                   ForeignKeyDirection foreignKeyDirection)
                   throws HibernateException

  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
  Returns:
    the value to be merged
  Throws:
    `HibernateException`

### toColumnNullness

    boolean[] toColumnNullness(Object value,
                               Mapping mapping)

  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Parameters:
    `value` - an instance of the type

Copyright © 2001-2010 Red Hat, Inc. All Rights Reserved.